import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.Date;
import java.rmi.*;
import java.net.URL;

public class Applet1 extends Applet
{
   private boolean     localDate = true;
   private TimeServer  ts;

   // UI Controls
   java.awt.Button    btnFetch;
   java.awt.TextField txtfldDateTime;
   java.awt.Checkbox  chkLocalRemote;
   
   public void init() 
   {
      super.init();
      
      buildUI();

      System.out.println( "TimeClientApplet...Initializing Time Applet" );
      URL base = getDocumentBase();
      System.out.println( "" + base );
      
      String serverName = "//" + base.getHost() + ":" + getParameter( "registryPort" ) + "/TimeService" ;
      
      System.out.println( serverName );
      
      txtfldDateTime.setText( serverName );
      
      try
      {
         ts = (TimeServer)Naming.lookup( serverName );
         
         try
         {
            chkLocalRemote.setEnabled( true );
         }
         catch ( NoSuchMethodError nsme )
         {
            
         }
         
      }
      catch ( Exception e )
      {
         System.out.println( "Remote Connection Failed" );
         System.out.println( "" + e );
         try
         {
            chkLocalRemote.setEnabled( false );
         }
         catch ( NoSuchMethodError nsme )
         {
         }
      }
   }

   private void buildUI()
   {
      setLayout( null );
      resize( 403, 31 );

      btnFetch = new java.awt.Button( "Fetch Date" );
      btnFetch.reshape( 200, 0, 80, 20 );
      add( btnFetch );

      txtfldDateTime = new java.awt.TextField();
      txtfldDateTime.reshape( 0, 0, 200, 20 );
      add( txtfldDateTime );
      
      chkLocalRemote = new java.awt.Checkbox( "Local" );
      chkLocalRemote.reshape( 288, 0, 72, 20 );
      add( chkLocalRemote );
      chkLocalRemote.setState(true);
   }
   
   
   public boolean handleEvent( Event e )
   {

      System.out.println( "" + e );
      // Toggle Local Time and Remote Time
      if ( (e.target == chkLocalRemote)  && ( e.id == Event.ACTION_EVENT ) )
      {
         if ( chkLocalRemote.getState() )
         {
            localDate = true;
         }
         else
         {
            localDate = false;
         }
         return true;
      }  // Toggle State

      // Request the time
      if ( ( e.target == btnFetch ) && ( e.id == Event.ACTION_EVENT ) )
      {
         String dateText;
         if ( localDate )
         {
            txtfldDateTime.setText( "" + (new Date()) );
         }
         else
         {
            try
            {
               txtfldDateTime.setText( "" + ts.getCurrentDate() );
            }
            catch( RemoteException re )
            {
               txtfldDateTime.setText( "TimeClientApplet...Error in RMI call" );
               System.out.println( "" + re );
            }
         }
         return true;

      }  // Request Time


      return super.handleEvent( e );
   }
}
